from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.ATBookmarks.config import *
from Products.CMFCore.utils import getToolByName

from StringIO import StringIO
ACTION_ICONS = {'plone':
                {'bookmarklivefeed':('atlivebookmark.png','Livebookmark RSS feed'),
                 'xbelxml':('xbel.png','xbel XML'),
                 'tastysibebar':('tastysidebar.png','Add Tasty Sidebar'),
                 }
                }
                
def install_cmfcpviews(self,out):
    """ Install Viewlets for CMFContentspanels"""
    try:
        from Products.CMFContentPanels import registerViewlets
        registerViewlets(VIEWLETS)
        out.write('Installed viewlets for CMFContentPanels \n')
    except:
        out.write('No viewlets for CMFContentspanels installed \n')

def install_actions(self, out):
    ai = getToolByName(self, 'portal_actionicons')
    for category, config in ACTION_ICONS.items():
        for icon_id, info in config.items():
            if ai.queryActionIcon(category, icon_id, None) is None:
                ai.addActionIcon(category, icon_id,
                                 info[0], info[1])
                out.write("Installed action icon "
                          "for %s.\n" % info[1])
            else:
                out.write(("Action Icon for %s "
                           "was already Installed.\n"
                           % info[1]))

def install(self):
    out = StringIO()
    
    installTypes(self, out,
                 listTypes(PROJECTNAME),
                 PROJECTNAME)
    install_actions(self, out)
    install_subskin(self, out, GLOBALS)
    install_cmfcpviews(self,out)
    # Enable portal_factory
    factory = getToolByName(self, 'portal_factory')
    types = factory.getFactoryTypes().keys()
    if 'BookmarkFolder' not in types:
        types.append('BookmarkFolder')
        factory.manage_setPortalFactoryTypes(listOfTypeIds = types)
    if 'SpotlightLink' not in types:
        types.append('SpotlightLink')
        factory.manage_setPortalFactoryTypes(listOfTypeIds = types)
        
    print >> out, "Added BookmarkFolder, SpotlightLink to portal_factory"

    ##
    ## Register BookmarkFolder as folderish content in plone, so it will
    ## get the appropriate folder_contents tabs
    props = self.portal_properties.site_properties
    tabs = getattr(props, 'use_folder_tabs')
    contents = getattr(props, 'use_folder_contents')

    if 'BookmarkFolder' not in tabs:
        newtabs = list(tabs)
        newtabs.append('BookmarkFolder')
        props._updateProperty('use_folder_tabs', newtabs)

    if 'BookmarkFolder' not in contents:
        newcontents = list(contents)
        newcontents.append('BookmarkFolder')
        props._updateProperty('use_folder_contents', newcontents)
    
    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()
