from Products.Archetypes.public import BaseSchema, Schema
from Products.Archetypes.public import StringField, StringWidget
from Products.Archetypes.public import TextField, TextAreaWidget
from Products.Archetypes.public import ImageField, ImageWidget
from Products.Archetypes.public import BaseContent, registerType
from Products.CMFCore import permissions
from config import PROJECTNAME

spotlightschema = BaseSchema +  Schema((
                    StringField('description',
                    isMetadata=1,
		    searchable=True,
                    accessor='Description',
                    widget=TextAreaWidget(label='Description', 
                                label_msgid='label_spotlight_desc',
                                description='A brief description of the link.',
                                description_msgid='help_description',
                                i18n_domain='ATBookmarks'),),
                    ImageField('spotlight_image',
                    widget=ImageWidget(label='Image for spotlight',
                                      label_msgid='label_spotlight_image',
                                      description='The Image used to visualize the link',
                                      description_msgid='help_spotlight_image',
                                      i18n_domain='ATBookmarks'),),
                    StringField('remote_url',
		    index='FieldIndex:Schema',
		    accessor='getRemoteUrl',
                    widget=StringWidget(label='URL of the featured site',
                                      label_msgid='label_spotlight_url',
                                      description='This links to the website.',
                                      description_msgid='help_spotlight_url',
                                      i18n_domain='ATBookmarks'),),   
                              ))

class SpotlightLink(BaseContent):
    """In The Spotlight for IW LEARN
    """
    schema = spotlightschema
    meta_type = 'Link'
    archetype_name = 'Featured Link'
    _at_rename_after_creation = True    
    content_icon = 'spotlight_icon.png'
    immediate_view = 'base_edit'
    default_view   = 'spotlight_view'
    global_allow = False
    
    actions = ({
        'id': 'view',
        'name': 'View',
        'action': 'string:${object_url}',
        'permissions': (permissions.View,)
        },)
    aliases = {
        '(Default)'  : 'spotlight_view',
        'view'       : 'spotlight_view',
        'index.html' : '',
        'edit'       : 'base_edit',
        'properties' : 'base_metadata',
        'sharing'    : 'folder_localrole_form',
        'gethtml'    : '',
        'mkdir'      : '',
        }

registerType(SpotlightLink, PROJECTNAME)
